# Petits exercices

Écrire d'abord *sur papier* en pseudocode un algorithme permetant de réaliser
les petits exercices suivants. Puis uniquement *dans un second temps* les
implémenter en C.

## Est unique?

Écrire une fonction qui vérifie si un tableau d'entiers contient au moins un
doublon.

Exemples:

```
{1, 5, 4, 2, 1, 2} -> vrai
{4, 2, 1, 5} -> faux
{0, 1, -1, -1} -> vrai
```

## Enlever les doublons

Écrire une fonction qui prend un tabeau d'entiers en argument et retourne un
tableau où tous les doublons ont été retirés.

Exemples:

```
{1, 5, 4, 2, 1, 2} -> {1, 5, 4, 2}
{4, 2, 1, 5} -> {4, 2, 1, 5}
{0, 1, -1, -1} -> {0, 1, -1}
```

## Compter le nombre d'occurrences d'un élément

Écrire une fonction qui prend un en argument un tableau d'entiers et un entier,
$n$, et retourne le nombre de fois où $n$ apparaît dans le tableau.

Exemples: 

```
{1, 5, 4, 2, 1, 2}, 5 -> 1
{4, 2, 1, 5, 1}, 1 -> 2
{0, 1, -1, -1}, 2 -> 0
```

## Déterminer quel élément a le plus d'occurrences

Écrire une fonction qui prend un en argument un tableau d'entiers et détermine
quel est le nombre apparaissant le plus grand nombre de fois dans le tableau,
ainsi que le nombre de fois où il apparaît. Si des nombes son ex-aequo prendre
celui qui apparaît en premier dans le tableau.

Exemples: 

```
{4, 2, 1, 5, 1}, 1 -> 1, 2
{0, 1, -1, -1, 0, 0}, 2 -> 0, 3
{1, 5, 4, 2, 1, 2}, 1 -> 1, 2
```

## Retirer la première occurence d'un élément dans un tableau

Écrire une fonction qui prend un en argument un tableau d'entiers et un entier,
$n$, et retourne un tableau où la première occurence de $n$ est retirée.

Exemples: 

```
{1, 5, 4, 2, 1, 2}, 5 -> {1, 4, 2, 1, 2}
{4, 2, 1, 5}, 1 -> {4, 2, 5}
{0, 1, -1, -1}, -1 -> {0, 1, -1}
```

## Retirer toutes les occurence d'un élément dans un tableau

Écrire une fonction qui prend un en argument un tableau d'entiers et un entier,
$n$, et retourne un tableau où toutes les occurences de $n$ sont retirées.

Exemples: 

```
{2, 1, 5, 4, 2, 1, 2}, 2 -> {1, 5, 4, 1}
{4, 2, 1, 5}, 1 -> {4, 2, 5}
{0, 1, -1, -1}, -1 -> {0, 1}
```

## Séparer un tableau en deux parties

Écrire une fonction qui prend un tableau d'entiers en argument, ainsi qu'un
indice, $i$, et le sépare en deux à l'indice $i$. 

Exemples: 

```
{2, 1, 5, 4, 2, 1, 2}, 2 -> {2, 1, 5}, {4, 2, 1, 2}
{4, 2, 1, 5}, 1 -> {4, 2}, {1, 5}
{0, 1, -1, -1}, 0 -> {0}, {1, -1, -1}
```


## Séparer un tableau en deux parties, bis

Écrire une fonction qui prend un tableau d'entiers en argument, ainsi qu'un
nombre, $n$, et le sépare en deux à la première occurence de l'élément $n$ s'il existe. 

Exemples: 

```
{2, 1, 5, 4, 2, 1, 2}, 2 -> {2}, {1, 5, 4, 2, 1, 2}
{4, 2, 1, 5}, 1 -> {4, 2, 1}, {5}
{0, 1, -1, -1}, 2 -> {0, 1, -1, -1}, {}
```

## En minuscules

Écrire une fonction qui prend une chaîne de caractères en entrée et retourne
une chaîne de caractères où toutes les lettres sont mises en minuscule.

Exemples: 

```
"Hello !" -> "hello !"
"WHAT IS HAPPENING" -> "what is happening"
"" -> "what is happening"
```

## En majuscules

Écrire une fonction qui prend une chaîne de caractères en entrée et retourne
une chaîne de caractères où toutes les lettres sont mises en majuscule.

Exemples: 

```
"Hello !" -> "hello !"
"WHAT IS HAPPENING" -> "what is happening"
"CSGO is not a game" -> "csgo is not a game"
```

## Inversion

Écrire une fonction qui prend une chaîne de caractères en entrée et retourne
une chaîne de caractères où on change la casse de toutes les lettres.

Exemples: 

```
"Hello !" -> "hELLO !"
"WHAT IS HAPPENING" -> "what is happening"
"CSGO is not a game" -> "csgo IS NOT A GAME"
```

## Écrire bizarrement

Écrire une fonction qui prend une chaîne de caractères en entrée et retourne
une chaîne de caractères où à chaque caractère on change la casse (peu importe
la casse de la chaîne en entrée) en commençant par une majuscule.

Exemples: 

```
"Hello !" -> "HeLlo !"
"WHAT IS HAPPENING" -> "WhAt Is HaPpEnInG"
"CSGO is not a game" -> "CsGo Is NoT A GaMe"
```

## Transformer des caractères en nombres entiers

Écrire une fonction qui prend une chaîne de caractères en entrée qui contient
que des chiffres de `0` à `9` et la transforme en nombre (interdiction
d'utiliser `atoi` évidemment).

Exemples: 

```
"1234" -> 1234
"012345" -> 12345
"0000000" -> 0
"-123" -> -123
```

## Nombres plus petits ou égaux

Écrire une fonction qui prend deux chaînes de caractères en entrée, `lhs` et
`rhs` respectivement et déterminant si `lhs <= rhs` où la règle `<=` est la
comparaison des entiers représentés par `lhs` et `rhs` respectivement

Exemples: 

```
"1234", "234" -> faux (1234 > 234)
"1234", "12345" -> vrai (1234 < 12345)
"1234", "1234" -> vrai (1234 == 1234)
"1234", "00123" -> faux (1234 > 123)
"-12345", "1234", "-12312" -> vrai (-12345 < 1234)
```

## Transformer des caractères en nombres à virgule

Écrire une fonction qui prend une chaîne de caractères en entrée qui contient
que des chiffres de `0` à `9` et au plus un `.` et la transforme en nombre à virgule (interdiction
d'utiliser `atof` évidemment).

Exemples: 

```
"1234.1" -> 1234.1
"012345" -> 12345.0
"0000.000" -> 0.0
"-123.6" -> -123.6
```


